<template>
  <div id="app">
    <h2>Graphische Auswertung</h2>
    <div class="graphics-container">
      <div class="select-scales">
        <h3>Zeitraum auswählen</h3>
        <div class="date-container">
          <datepicker class='datepicker' placeholder="Start Datum" v-model="startDate"></datepicker>
          <datepicker class='datepicker' placeholder="End Datum" v-model="endDate"></datepicker>
        </div>
        <!--
        <h3>Filterung Auswählen</h3>
        <div 
          v-on:click="filterByProduct" 
          v-bind:class="{'is-selected':this.productSelected}"
          class="btn">Produkt</div>
        <div 
          v-on:click="filterByCategory" 
          v-bind:class="{'is-selected':this.categorySelected}"
          class="btn">Kategorie</div> -->
        <h3>Granularität Auswählen</h3>
        <div 
          v-on:click="filterByDaily" 
          v-bind:class="{'is-selected':this.daySelected}"
          class="btn">Tag</div>
        <!--<div 
          v-on:click="filterByWeekly" 
          v-bind:class="{'is-selected':this.weekSelected}"
          class="btn">Woche</div>-->
        <div 
          v-on:click="filterByMonthly" 
          v-bind:class="{'is-selected':this.monthSelected}"
          class="btn">Monat</div>
        <div 
          v-on:click="filterByYearly" 
          v-bind:class="{'is-selected':this.yearSelected}"        
          class="btn">Jahr</div>        
        <div v-on:click="calculate" class="btn calculate">Graphik berechnen</div>
      </div>
      <div class="graphics">
        <Graphics :key="graphicsKey" v-bind:items="currentitems" v-bind:title="title"/>
      </div>
    </div>
  </div>
</template>

<script>
  import Graphics from '../components/graphics/Graphics';
  import Datepicker from 'vuejs-datepicker';
  import ShoppingsService from '../services/ShoppingsService';

  export default {
    name: 'ShoppingGraphics',
    components: {
      Graphics,
      Datepicker
    },
    data() {
      return {
        items: [],
        currentitems: [],
        xlabel: '',
        ylabel: '',
        startDate: '',
        endDate: '',
        productSelected: false,
        categorySelected: false,
        daySelected: false,
        weekSelected: false,
        monthSelected: false,
        yearSelected: false,
        graphicsKey: 0,
        title: '',
      }
    },
    async created() {
      this.items = await ShoppingsService.getItems();      
      this.setFilterToDefault();
      this.setTimeToDefault();
      var sum = 0.0;
      this.items.forEach(element => {
        sum += this.parseFloat(element.price);
        console.log(this.parseFloat(element.price));
      });
      console.log(sum);
    },
    methods : {
      parseFloat(e)
      {
        if(typeof e === 'number')
          return e;
        return parseFloat(e.replace(/,/g, "."));
      },
      filterByProduct() {
        this.setFilterToDefault();
        this.productSelected = true;
      },
      filterByCategory() {
        this.setFilterToDefault();
        this.categorySelected = true;
      },

      filterByDaily() {
        this.setTimeToDefault();
        this.daySelected = true;
      },
      filterByWeekly() {
        this.setTimeToDefault();
        this.weekSelected = true;
      },
      filterByMonthly() {
        this.setTimeToDefault();
        this.monthSelected = true;
      },
      filterByYearly() {
        this.setTimeToDefault();
        this.yearSelected = true;
      },

      setFilterToDefault() {
        this.productSelected = false;
        this.categorySelected = false;
      },
      setTimeToDefault() {
        this.daySelected = false;
        this.weekSelected = false;
        this.monthSelected = false;
        this.yearSelected = false;
      },

      calculate() {
        if((this.daySelected || this.monthSelected || this.yearSelected)
          && (this.startDate !== '' && this.endDate !== '' ))
          {
            console.log("Calculate");
            this.startDate.setHours(0,0,0,0);
            this.endDate.setHours(0,0,0,0);
            // Innerhalb des Intervals:
            //   Innerhalb jedes Zeitabschnitts
            //     Kumuliere die Ausgaben pro Kategorie
            //     Zeichne Balken über die Gesamtausgaben
            //     Segmentiere Balken in die einzelnen Kategorien nach Ausgaben
            // Map Reduce Filter: https://medium.com/poka-techblog/simplify-your-javascript-use-map-reduce-and-filter-bd02c593cc2d

            // Erstelle ein Array mit allen Datensätzen innerhalb des Intervals            
            var filteredItems = this.items.filter((item) => {
              return item.createdAt >= this.startDate && item.createdAt <= this.endDate;
            });
            
            var dateIntervals = [];
            var currentDate = new Date(this.startDate);
            dateIntervals.push(new Date(this.startDate));
            if(this.daySelected)
            {
              this.title = 'Day';
              while(currentDate < this.endDate)
              {
                currentDate.setDate(currentDate.getDate() +1);
                dateIntervals.push(new Date(currentDate));
              }
            }
            else if(this.monthSelected)
            {
              this.title = 'Month';
              while(currentDate < this.endDate)
              {
                currentDate.setMonth(currentDate.getMonth() +1);
                dateIntervals.push(new Date(currentDate));
              }
            }
            else if(this.yearSelected)
            {
              this.title = 'Year';
              while(currentDate < this.endDate)
              {
                currentDate.setFullYear(currentDate.getFullYear() +1);
                dateIntervals.push(new Date(currentDate));
              }
            }

            var intervalData = [];            
            for (let i = 0; i < dateIntervals.length; i++)
            {
              intervalData.push(filteredItems.filter(item => {
                return item.createdAt >= dateIntervals[i] && item.createdAt <= dateIntervals[i+1];
              }));
            }

            var intervalCosts = [];
            for(let i = 0; i < intervalData.length; i++)
            {   
              // if(!Array.isArray(intervalData[i]) || intervalData[i].length === 0)
              //   continue;
              intervalCosts.push(
              {
                "id" : intervalCosts.length,
                "date": new Date(dateIntervals[i]), 
                "price": intervalData[i].reduce((cumulatedPrice, item) => this.parseFloat(cumulatedPrice) + this.parseFloat(item.price), this.parseFloat(0.0))
              });
            }

            this.currentitems = intervalCosts;
            this.graphicsKey += 1;
          }
          else
          {
            console.log("Einstellungen sind nicht ausreichend");
          }
      },      
    }
  };
</script>

<style>
  * {
    box-sizing: border-box;
    margin: 0;
    padding: 0;    
  }

  body {
    font-family: Arial, Helvetica, sans-serif;
    line-height: 1.4;

  }

  .btn {
    display: block;
    border: none;
    background: #555;
    color: #fff;
    padding: 7px 20px;
    cursor: pointer;
  }

  .btn:hover {
    background: #888;
  }
  .calculate{
    margin-top: 20px;
  }

  .is-selected {
    background-color: #777;
  }
  
  /* dies ist ein mobile first Ansatz */

  div.graphics-container {
    display: flex;
    flex-wrap: wrap;
  }

  .select-scales {
    width: 100%;
    padding: 10px;
    background: #555;
  }

  .select-scales h3{
    padding-top: 10px;
    color: #fff;
    width: 100%;
    border-bottom: 1px dotted #fff;
    margin-bottom: 10px;
  }  

  .datepicker input{
    background-color: #fff;
    color: #000;
    width: 100%;
    padding: 10px;
    
  }

  .graphics {
    width: 100%;
    border: solid 1px #000;
    padding: 10px;
    min-height:300px;
  }

  @media screen and (min-width: 700px) {
    .select-scales{
      width: 30%;
    }
    .graphics {
      width: 70%;
      min-height: 500px;
    }
  }

  @media screen and (min-width: 1400px) {
    .select-scales{
      width: 20%;
    }
    .graphics {
      width: 80%;
      min-height: 700px;
    }
  }

</style>
